//---------------------------------------------------------------------------------------
// File          : ztec_com_count.v
// Project       : FPGA Thermal Design Reserarch
// Created       : 2016/12/01
// Last Author   : $Author:$
// Last modified : $Date:$
// Revision      : $Revision:$
//---------------------------------------------------------------------------------------
// Copyright (c) 2016 by Zuken Tec Inc.
//---------------------------------------------------------------------------------------

// counter (common module)
module ztec_com_count ( ck, rx, cl, en, ct );

    parameter p_width = 4;   // bit width   ( width >= 1 )
    parameter P_DL    = 1;   // FF delay
    
    input                ck; // clock
    input                rx; // async reset (active low)
    input                cl; // count clear
    input                en; // count enable
    output [p_width-1:0] ct; // count value

    reg    [p_width-1:0] ff_count; // FF
    
    always @( posedge ck or negedge rx )begin
        if     ( ~rx ) ff_count <= {p_width{1'd0}};
        else if(  cl ) ff_count <= #P_DL {p_width{1'd0}};
        else if(  en ) ff_count <= #P_DL ff_count + 1;
    end

    assign ct = ff_count;
    
endmodule

/* RTL instantiation template
 
 case1
  ztec_com_count #(16) cnt_01 ( .ck(clk_in), .rx(rst_x), .cl(clr), .en(ff_en), ,ct(count) );
 
 case2
  ztec_com_count #(8) cnt_02
    (
     .ck ( clk_in          ), // _i_
     .rx ( rst_x           ), // _i_
     .cl ( cnt_clr         ), // _i_
     .en ( cnt_en          ), // _i_
     .ct ( count           )  // _o_
     );

 */

